-- File            : CLEAN2.SQL
-- Author          : Georg Verweyen
-- Description     : Entfernt Titel usw. aus der Vornamenliste
-- Tabellen        : Tbl_Vornamen
--                   - vorname    (Read)
--                   - status     (Write)
--                   - korrigiert (Write)
--                   - stamm      (Write)
--
-- Bentigt die Funktion CLEAN_PRE_STRING !!
--
spool clean2.log

set serveroutput on;
select status, count(*) 
  from tbl_vornamen
 group by status
;
select to_char(sysdate,'dd.mm.yyyy hh24:mi:ss') from dual;

declare cursor cur_work is
  select vorname, rowid 
    from Tbl_Vornamen
   where status = 'eingelesen'
  ;

  var_result       Tbl_Vornamen.vorname%TYPE;
  Var_result1      Tbl_Vornamen.vorname%TYPE;
  Var_status       Tbl_Vornamen.status%TYPE;
  Var_count        number;
  Con_Commit_Point integer := 16;

begin
  Var_count := 0;
  FOR rec_work in cur_work LOOP
    Var_result := upper(rec_work.vorname);
    Var_status := 'bearbeitet';
--
-- Entfernung eines Titels
--
    IF length(Var_result)> 0 THEN
      Var_result1:= Var_result;

--
--    Beobachtete Titelschreibweise
--
      Var_result := clean_pre_string (Var_result,'PROF.');
      Var_result := clean_pre_string (Var_result,'DR.');
      Var_result := clean_pre_string (Var_result,'DIPL.');
      Var_result := clean_pre_string (Var_result,'DIPL ');
      if var_result <> var_result1 then
        Var_result := clean_pre_string (Var_result,'JUR.');
        Var_result := clean_pre_string (Var_result,'MED.');
        Var_result := clean_pre_string (Var_result,'MED ');
        Var_result := clean_pre_string (Var_result,'INF.');
        Var_result := clean_pre_string (Var_result,'PSYCH.');
        Var_result := clean_pre_string (Var_result,'PSYCHOLOGIN');
        Var_result := clean_pre_string (Var_result,'PSYCHOLOGE');
        Var_result := clean_pre_string (Var_result,'VET.');
        Var_result := clean_pre_string (Var_result,'ING.');  -- Reihenfolge nach Dipl[.]
        Var_result := clean_pre_string (Var_result,'KFM.');
        Var_result := clean_pre_string (Var_result,'KAUFM.');
        Var_result := clean_pre_string (Var_result,'RER.');
        Var_result := clean_pre_string (Var_result,'RER ');
        Var_result := clean_pre_string (Var_result,'POL.');
        Var_result := clean_pre_string (Var_result,'POL ');
      End if;
      Var_result := clean_pre_string (Var_result,'FR.');   -- Reihenfolge beachten
      Var_result := clean_pre_string (Var_result,'HR.');
      IF Var_result <> Var_result1 THEN
        Var_status := 'Titel entfernt';
--      dbms_output.put_line(Var_result1);  
      END IF;
   END IF;
--
-- Falsche Anrede bei GmbH und OHG
--
   IF length(Var_result)>0 THEN
      IF instr(Var_result,'GMBH')+instr(Var_result,'OHG')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      -- AG am Ende stehend!
      IF instr(Var_result,' AG')=length(Var_result)-3 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      IF instr(Var_result,'BRO')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      IF instr(Var_result,'FIRMA')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      IF instr(Var_result,'FAHRSCHULE')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      IF instr(Var_result,'STEUERBERATER')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
      IF instr(Var_result,'RECHTSANW')>0 THEN
        Var_status := 'Falsche Anrede';
        Var_result := '';
      END IF;
   END IF;
--
-- Nur Satzzeichen entfernen ...
--
   IF Var_result = RPAD('.',length(Var_result),'.') THEN
      Var_result := '';
      Var_status := 'Sonderzeichen';
   end if;
   IF Var_result = RPAD('-',length(Var_result),'-') THEN
      Var_result := '';
      Var_status := 'Sonderzeichen';
   end if;
   IF Var_result = RPAD(',',length(Var_result),',') THEN
      Var_result := '';
      Var_status := 'Sonderzeichen';
   end if;
   IF Var_result = RPAD('!',length(Var_result),'!') THEN
      Var_result := '';
      Var_status := 'Sonderzeichen';
   END IF;
--
-- Zahlen 
--
   if instr(Var_result,'0')+instr(Var_result,'1')+instr(Var_result,'2')+
      instr(Var_result,'3')+instr(Var_result,'4')+instr(Var_result,'5')+
      instr(Var_result,'6')+instr(Var_result,'7')+instr(Var_result,'8')+
      instr(Var_result,'9') > 0
   then
      Var_result := '';
      Var_status := 'Sonderzeichen';
   end if;
--
-- Falsche Anrede bei mehreren Personen
--
   -- dbms_output.put_line(Var_result);
   -- dbms_output.put_line(instr(var_result,'/') || ' ' || length(var_result));
   IF length(Var_result)>0 THEN
      -- dbms_output.put_line('Bedingung 1');
      IF instr(Var_result,' UND ')>0 THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
      END IF;
      IF substr(Var_result,1,4) = 'UND ' THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
      END IF;
      IF instr(Var_result,' U. ')>0 THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
      END IF;
      IF (instr(Var_result,'+')>0) and (instr(Var_result,'+')<length(Var_result)) THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
      END IF;
      IF (instr(Var_result,'/')>0) and (instr(Var_result,'/')<length(Var_result)) THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
        -- dbms_output.put_line(Var_status);
      END IF;
      IF (instr(Var_result,'&')>0) and (instr(Var_result,'&')<length(Var_result)) THEN
        Var_status := 'mehrere Pers.';
        Var_result := '';
      END IF;
   END IF;
--
-- Bindestrich und Komma entfernen
--
   while instr(Var_result,'-') > 0 loop
     Var_result := substr(Var_result,1,instr(Var_result,'-')-1) ||' ' || substr(Var_result,instr(Var_result,'-')+1);
   end loop;
   while instr(Var_result,',') > 0 loop
     Var_result := substr(Var_result,1,instr(Var_result,',')-1) ||' ' || substr(Var_result,instr(Var_result,',')+1);
   end loop;
   while instr(Var_result,'.') > 0 loop
     Var_result := substr(Var_result,1,instr(Var_result,'.')-1) ||' ' || substr(Var_result,instr(Var_result,'.')+1);
   end loop;
--
-- 2 oder mehr  Blank's mit einem Blank ersetzen
--
   while instr(Var_result,'  ') > 0 loop
     Var_result := substr(Var_result,1,instr(Var_result,'  ')-1) ||' ' || substr(Var_result,instr(Var_result,'  ')+2);
   end loop;
   --
   if substr(var_result,length(var_result),1)=' ' then
     var_result := substr(Var_result,1,length(Var_result)-1);
   end if;
   --
   if substr(var_result,1,1)=' ' then
     var_result := substr(Var_result,2);
   end if;
--
-- Berechnung des Stamm-Namen
--
   Var_result1 := Var_result;
   if instr(Var_result1,' ')>0 then
     Var_result1 := substr(Var_result1, 1, instr(Var_result1,' ') - 1); 
   end if;
--
-- Wegschreiben des Ergebnis
--
    update Tbl_Vornamen
       set korrigiert = Var_result
           , status   = Var_status
           , stamm    = Var_result1
     where rowid = rec_work.rowid
    ;
    Var_count := Var_count + 1;
    IF Var_count = Con_Commit_Point THEN
      commit;
      Var_count := 0;
    END IF;
  END LOOP;
  COMMIT;
END;
/
select to_char(sysdate,'dd.mm.yyyy hh24:mi:ss') from dual;
select status, count(*) 
  from tbl_vornamen
 group by status
;
spool off;
