-- File            : FUNCTION_CLEAN_STRING.SQL
-- Author          : Georg Verweyen
-- Description     : Lscht den angegebenen Prefix aus der Zeichenkette, wenn und vorhanden 
--                   ist, und auch eventuell danach folgende Blanks.
--
--                   Einsatzmglichkeit: Lschen vor "Dr." aus Vornamenfelder
--                   update tbl_vorname
--                      set vorname = clean_pre_string (vorname, 'Dr.')
--                    where vorname like 'Dr. %' -- Where nur um Anzahl der Updates zu reduzieren!
--                   ;
--
create or replace function clean_pre_string (Zeichenkette in varchar2, PreFix in varchar2) 
  return varchar2 IS
  result varchar2(40);
begin
  result := ZeichenKette;
  WHILE substr(result,1,length(PreFix)) = PreFix LOOP
    result := substr(result,length(PreFix)+1);
    WHILE (substr(result,1,1) = ' ') or (substr(result,1,1) = '-') LOOP
      result := substr(result,2);
    END LOOP;
  END LOOP;
  RETURN result;
end;
/
show errors

